module Platformx
  module AuthHelpers

    # Admin session helpers

    # Checks if the current user authorizes as an admin
    #
    # @return [Boolean] if current user authorizes as an admin
    def x_admin_authorized?
      session[:admin_authorized]
    end

    # Authorizes the current user as an admin or redirects the user to the admin login page.
    def x_admin_authorize!
      redirect '/admin/login' unless x_admin_authorized? || request.url.include?("/admin/login")
    end

    # Logs out the amdin
    def x_admin_logout!
      session[:admin_authorized] = false
      session.clear
    end

    # User session helpers

    # Checks if the user is logged in
    #
    # @return [Boolean] if uesr logged in
    def x_authorized?
      session[:authorized]
    end

    # Authorizes the user and redirects the user to the registration page.
    def x_authorize!
      redirect '/login' unless x_authorized? || request.url.include?("/login") || request.url.include?("/auth")
    end

    # Logs out the currenly logged in user
    def x_logout!
       session[:authorized] = false
       session.clear
    end

    # Encyrption helprs
    
    # Encodes a value to a base 64 string.
    #
    # @note The provided object should respond to `#to_s` to obtain a string representation of the object.
    #
    # @param int [Object] the value required to be encrypted
    #
    # @return [String] encoded string
    def x_encrypt(int = "")
      str = int.to_s
      #encrypted_value = Encryptor.encrypt(:value => str, :key => "=PeuMX7B4LQ#@jG*s;tYGdF")
      return Base64.urlsafe_encode64(str)
    end

    # Decodes an encoded string
    #
    # @param str [String] the encoded string
    #
    # @return [String] decoded string
    def x_decrypt(str = "")
      str = Base64.urlsafe_decode64(str)
      #decrypted_value = Encryptor.decrypt(:value => str, :key => '=PeuMX7B4LQ#@jG*s;tYGdF')
      return str.to_i
    end

    # Generate a random password
    #
    # @param len [Integer] the length of the password
    #
    # @return [String] random generated password
    def x_generate_password(len = "10")
      random_password = Array.new(len).map { (65 + rand(58)).chr }.join
      return random_password
    end

  end
end
